using System;
using System.Collections.Generic;
using Couchbase;
using Couchbase.Authentication;
using Couchbase.Configuration.Client;
using Couchbase.Core;

namespace rbac_data_writer_test
{
	class Program
	{
		static void Main()
		{
			var cluster = new Cluster(new ClientConfiguration
			{
				Servers = new List<Uri> {new Uri("http://10.112.170.101")}
			});

			var authenticator = new PasswordAuthenticator("datawriter", "password");
			cluster.Authenticate(authenticator);
			var bucket = cluster.OpenBucket("default");

			var key = "key";

			var mutateResult = bucket.MutateIn<dynamic>(key).Upsert("goodbye", "world", SubdocPathFlags.CreatePath).Execute();
			Console.Write("ResultMutateIn:");
			Console.WriteLine(mutateResult.Success);

			var lookupResult = bucket.LookupIn<dynamic>(key).Get("goodbye").Execute();
			Console.Write("ResultLookupIn:");
			Console.WriteLine(lookupResult.Success ? lookupResult.Content("goodbye") : "<none>");

			var getResult = bucket.GetDocument<dynamic>(key);
			Console.Write("ResultGet:");
			Console.WriteLine(getResult.Success ? getResult.Document.Content : "<none>");

			Console.ReadKey(true);
		}
	}
}
